//////////////////////////////
// gdx_indi.c
// written by Michael Gibson
// released under the GPl
//////////////////////////////

#include <stdio.h>
#include <string.h>
#include <GDXlib/GDXlib.h>



/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}



//////////////////////////////////////////////////
// main
/////////////////////////////////////////////////
int main(int argc, char **argv){

  char indi_name[95];
  int  indi_name_t;

  char indi_sex[7];
  int  indi_sex_t;

  char indi_birthdate[90];
  int  indi_birthdate_t;
  char indi_birthplace[90];
  int  indi_birthplace_t;

  char indi_deathdate[90];
  int  indi_deathdate_t;
  char indi_deathplace[90];
  int  indi_deathplace_t;


  char input1[95], input2[95];
  int individual;
  int button_01;
  char indi_check[55];  
  int flag1=0;
  int x=0;
  int line=5;
  int indi_found=0;

  int loopy=0;

  FILE *fp5;

  fp5=fopen(argv[1],"r+");

  x_open();

  /* create a new window */
  gdx_window("GEDCOM Individual",500,400);
  gdx_setwindowbg("bg.xpm",1);


  button_01 = gdx_imagebutton(5,25,"close.xpm",destroy);

  gdx_label(argv[2],35,15,1);
  
  printf("%s %s %s\n",argv[0],argv[1],argv[2]);

  do{

    loopy++;

    //check for level 0

    fscanf(fp5,"%s",input1);

    if (input1[0]=='0'){

      //OK, we have a level 0

      fscanf(fp5,"%s",input1);
      fscanf(fp5,"%s",input2);


      //check for an individual

      if(input1[0]=='@'&& input1[1]=='I' && input2[0]=='I' && input2[1]=='N'){
        indi_found=1;
      }

      if(indi_found==1){

        //Great!, the level 0 is an individual

        x=0; 
        do{
          indi_check[x]=input1[x+2];
          x++;
        }while(indi_check[x-1]!='@');
        indi_check[x-1]='\0'; 
        indi_check[x]='\0';

        //check to see if it is the idividual we are looking for 

        printf("check '%s' = '%s'\n",indi_check,argv[2]);
        if(atoi(indi_check)==atoi(argv[2])){

          //hot grits! it is the idividual we were looking for

          //now read in the individual's information

          do{

            fscanf(fp5,"%s",input1);


            if(strcmp(input1,"NAME")==0){
              strcpy(indi_name," ");
              do{
                fscanf(fp5,"%s",input1);
                strcat(indi_name,input1);
                strcat(indi_name," ");
              }while(input1[0]!='/');
              gdx_label("Name:",35,35,0);
              //gdx_label(indi_name,125,25,1);
              indi_name_t=gdx_textentry(125,25,200,0);
              gdx_settextentry(indi_name_t,indi_name);
            }


            if(strcmp(input1,"SEX")==0){
              strcpy(indi_sex," ");
              fscanf(fp5,"%s",input1);
              strcpy(indi_sex,input1);
              gdx_label("Sex:",35,60,0);
              //gdx_label(indi_sex,125,50,1);
              indi_sex_t=gdx_textentry(125,50,20,0);
              gdx_settextentry(indi_sex_t,indi_sex); 
            }


            if(strcmp(input1,"BIRT")==0){
              strcpy(indi_birthdate," ");
              strcpy(indi_birthplace," ");
              fscanf(fp5,"%s",input1);
              printf("SUB individual data read '%s'\n",input1);
              fscanf(fp5,"%s",input1);
              printf("SUB individual data read '%s'\n",input1);
              if(strcmp(input1,"DATE")==0){
                do{
                  fscanf(fp5,"%s",input1);
                  printf("SUB individual data read '%s'\n",input1);
                  if(strcmp(input1,"0")!=0 && strcmp(input1,"1")!=0 && strcmp(input1,"2")!=0) strcat(indi_birthdate,input1);
                  strcat(indi_birthdate," ");
                }while(strcmp(input1,"0")!=0 && strcmp(input1,"1")!=0 && strcmp(input1,"2")!=0);
                gdx_label("Birth Date:",35,85,0);
                //gdx_label(indi_birthdate,125,85,1);
                indi_birthdate_t=gdx_textentry(125,75,100,0);
                gdx_settextentry(indi_birthdate_t,indi_birthdate);
              }
              if(strcmp(input1,"2")==0){
                fscanf(fp5,"%s",input1);
                printf("SUB individual data read '%s'\n",input1);
               
                if(strcmp(input1,"PLAC")==0)do{
                  fscanf(fp5,"%s",input1);
                  printf("SUB individual data read '%s'\n",input1);
                  if(strcmp(input1,"0")!=0 && strcmp(input1,"1")!=0 && strcmp(input1,"2")!=0)
                    strcat(indi_birthplace,input1);
                  strcat(indi_birthplace," ");
                }while(strcmp(input1,"0")!=0 && strcmp(input1,"1")!=0 && strcmp(input1,"2")!=0);
                gdx_label("Birth Place:",35,110,0);
                //gdx_label(indi_birthplace,125,110,1);
                indi_birthplace_t=gdx_textentry(125,100,300,0);
                gdx_settextentry(indi_birthplace_t,indi_birthplace);
              }
            }




            if(strcmp(input1,"DEAT")==0){
              strcpy(indi_deathdate," ");
              strcpy(indi_deathplace," ");
              fscanf(fp5,"%s",input1);
              printf("SUB individual data read '%s'\n",input1);
              fscanf(fp5,"%s",input1);
              printf("SUB individual data read '%s'\n",input1);
              if(strcmp(input1,"DATE")==0){
                do{
                  fscanf(fp5,"%s",input1);
                  printf("SUB individual data read '%s'\n",input1);
                  if(strcmp(input1,"0")!=0 && strcmp(input1,"1")!=0 && strcmp(input1,"2")!=0)
                    strcat(indi_deathdate,input1);
                  strcat(indi_deathdate," ");
                }while(strcmp(input1,"0")!=0 && strcmp(input1,"1")!=0 && strcmp(input1,"2")!=0);
                gdx_label("Death Date:",35,135,0);
                //gdx_label(indi_deathdate,125,135,1);
                indi_deathdate_t=gdx_textentry(125,125,100,0);
                gdx_settextentry(indi_deathdate_t,indi_deathdate);
              }
              if(strcmp(input1,"2")==0){
                fscanf(fp5,"%s",input1);
                printf("SUB individual data read '%s'\n",input1);

                if(strcmp(input1,"PLAC")==0)do{
                  fscanf(fp5,"%s",input1);
                  printf("SUB individual data read '%s'\n",input1);
                  if(strcmp(input1,"0")!=0 && strcmp(input1,"1")!=0 && strcmp(input1,"2")!=0)
                    strcat(indi_deathplace,input1);
                  strcat(indi_deathplace," ");
                }while(strcmp(input1,"0")!=0 && strcmp(input1,"1")!=0 && strcmp(input1,"2")!=0);
                gdx_label("Death Place:",35,160,0);
                //gdx_label(indi_deathplace,125,160,1);
                indi_deathplace_t=gdx_textentry(125,150,300,0);
                gdx_settextentry(indi_deathplace_t,indi_deathplace);
              }
            }







          //stop when I get to the next idividual

          }while(input1[0] != '0' );

          flag1=22;
        }
      }//if indi

    }//if 0 level


    if(input1[0]=='\0'){

      flag1=22;
      gdx_label("File read error!",50,50,1);
      printf("NULL found!");
    }
   
  }while(flag1!=22 && strcmp(input1,"TRLR")!=0 && strcmp(input2,"TRLR")!=0);


  gdx_main();
  x_close();

  return(0);
}

