//////////////////////////////
// start.c
// written by Michael Gibson
// released under the GPl
//////////////////////////////

#include <stdio.h>
#include <string.h>

#ifdef WIN32
  #include "GDXlib\\GDXlib.h"
#endif

#ifndef WIN32
  #include <GDXlib/GDXlib.h>
#endif

/////////////////////////////////////////////////////
///// new file 
/////////////////////////////////////////////////////
static void newfile(void)
{

    #ifdef WIN32
      system(".\\gdx_firstdata&");
    #endif

    #ifndef WIN32
      system("./gdx_firstdata&");
    #endif

    gdx_closewindow();
}




/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}



//////////////////////////////////////////////////
// main
/////////////////////////////////////////////////
int main(int argc, char **argv){

  int button_01, button_02, button_03;

  printf("Starting GUI.\n");

  x_open();

  /* create a new window */
  gdx_window("Start Wizard",500,300);
  gdx_setwindowbg("bg.xpm",1);

  gdx_image(5,5,"wizard.xpm");

  gdx_label("What do you wish to do?",225,25,0);

  button_01 = gdx_button(225,50,"Create a new GEDCOM",newfile);
  button_02 = gdx_button(225,75,"Open an existing GEDCOM",destroy);
  button_03 = gdx_button(225,250,"Exit please", destroy);

  gdx_main();
  x_close();

  return(0);
}

